package cn.iocoder.yudao.module.system.service.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.*;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceProductDO;
import cn.iocoder.yudao.module.system.dal.dataobject.biz.DeviceWarnUserDO;

import javax.validation.Valid;
import java.util.List;

public interface DeviceProductService {

    /**
     * 创建设备产品
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProduct(@Valid DeviceProductSaveReqVO createReqVO);

    /**
     * 更新设备产品
     *
     * @param updateReqVO 更新信息
     */
    void updateProduct(@Valid DeviceProductSaveReqVO updateReqVO);

    /**
     * 删除设备产品
     *
     * @param id 编号
     */
    void deleteProduct(Long id);

    /**
     * 获得设备产品
     *
     * @param id 编号
     * @return 设备产品
     */
    DeviceProductDO getProduct(Long id);

    /**
     * 获得设备产品分页
     *
     * @param pageReqVO 分页查询
     * @return 设备产品分页
     */
    PageResult<DeviceProductRespVO> getProductPage(DeviceProductPageReqVO pageReqVO);

    PageResult<DeviceProductRespVO> getAllDeviceProductPage(DeviceProductPageReqVO pageReqVO);

    DeviceProductDetailVO getDetail(Long id);

    DeviceProductDO getByDeviceMac(String devID);

    Integer bindDevice(BindingDeviceReqVO updateReqVO);

    Integer unbindDevice(Long id);

    Boolean updateBatchBind(BindingAllDeviceReqVO updateReqVO);

    Boolean groupBatchDelete(BindingAllDeviceReqVO updateReqVO);

    Boolean groupBatchBind(BindingAllDeviceReqVO updateReqVO);

    Boolean groupBatchUnbind(BindingAllDeviceReqVO updateReqVO);

    List<DeviceWarnUserDO> getWarnUserList(Long id);

    Boolean updateWarnUser(DeviceWarnUserUpdateReqVO deviceWarnUserUpdateReqVO);

    int delectWarnUserById(Long id);
}
